<?php
/***************************************************
 * 文件型缓存支持类 
*****************************************************/
namespace phpGrace\tools\caches;

class fileCacher{
	private static $cacher = null;
	
	private function __construct($config){
		if(!is_dir(PG_CACHEDATAFILES)){mkdir(PG_CACHEDATAFILES, 0777, true);}
	}
	
	public static function getInstance($config){
		if(self::$cacher == null){self::$cacher = new fileCacher($config);}
		return self::$cacher;
	}
	
	public function get($name){
		$cacheFile = PG_CACHEDATAFILES.'/'.$name.'.php';
		if(!is_file($cacheFile)){return false;}
		$cacheData = require $cacheFile;
		$cacheData = unserialize($cacheData);
		if($cacheData['expire'] < time()){return false;}
		return $cacheData['data'];
	}
	
	public function set($name, $data, $expire){
		$cacheFile = PG_CACHEDATAFILES.'/'.$name.'.php';
		$cacheContent = '<?php
if(!defined("PG_PATH")){exit();}
$data = <<<EOF
';
		$cacheData = array(
			'data'   => $data,
			'expire' => time() + $expire
		);
		$cacheData = str_replace('\\', '\\\\', serialize($cacheData));
		$cacheData = str_replace('$', '\$', $cacheData);
		$cacheContent .=  $cacheData.'
EOF;
return $data;';
		file_put_contents($cacheFile, $cacheContent);
	}
	
	public function removeCache($name){
		$cacheFile = PG_CACHEDATAFILES.'/'.$name.'.php';
		if(!is_file($cacheFile)){return true;}
		unlink($cacheFile);
		return true;
	}
	
	public function clearCache(){
		$files = scandir(PG_CACHEDATAFILES);
		foreach($files as $v){
			if($v != '.' && $v != '..'){
				$cacheUrl = PG_CACHEDATAFILES.'/'.$v;
				if(is_file($cacheUrl)){
					@unlink($cacheUrl);
				}
			}
		}
		return true;
	}
	
	public function close(){
		
	}
}