<?php
/**
 * 文件功能  : 处理超星网盘的一些操作
 * Copyright: (c) 2023  .All rights reserved.
 * Author   : 扣扣小妖
 * email    : liukuaizhuan@qq.com
 * Date     : 2023/4/23 15:50
 * Licensed : http://www.apache.org/licenses/LICENSE-2.0
 */
namespace phpGrace\tools;
class chaoxing{
    public $set_ChaoXing_Cookie='';    #设置超星盘的Cookie  在用户数据库里面提取
    public  $uploadUrl = 'https://pan-yz.chaoxing.com/upload'; # 超星网盘上传接口地址
    public $bilili_cookie ='';
    /***
     * 上传到ice-editor编辑器，不存数据库 ,且json编码过，前端不需要再次编码 支持截图粘贴上传图
     * 注意：ice-editor编辑器上传图片和附件是通过遍历的形式
     * @param $field 默认上传字段接口 有的时候name需要为file[]
     * @return false|string
     */
    public function uploadToiceEditorPanTypeChaoxing( $field = 'file')
    {
        // 默认定义返回图片或者附件的空URL ，用于上传错误时候定义样式填充
        $tempUrl = '';
        //获取批量上传的数组键值，也就是说上传的文件数量
        $keys = array_keys($_FILES[$field]['name']);
        foreach ($keys as $key){
            # 获取上传文件信息
            $file = $_FILES[$field];
            //获取文件的类型
            $fileType = $file['type'][$key];
            //用来处理文件名 ，截图数据的文件名非完整图片名，需要拼接写
            $TempName = $file['name'][$key];
            $pinName = $this->tempGetBoldName($TempName,$fileType);
            # 设置 POST 请求的参数
            $postData = array(
                "puid"      =>  258413163,
                "_token"    =>  "9910536ff44a3fef3726f34f67c1d0b2",
                "prdid"     =>  440,
                'file'      => new \CURLFile($file['tmp_name'][$key], $fileType, $pinName)
            );
            # 创建 cURL 请求
            $response = $this->post_curl($this->uploadUrl,$postData);
            # 处理网盘上传的响应结果
            $result = json_decode($response, true);
            # 处理数据
            if ($result && $result['result']  ==  1 ) {
                # 获取上传成功后的文件后缀名
                $fileType = $result['data']['suffix'];
                # 根据后缀名统一规划文件类型
                $fileType = $this->getFileType($fileType);
                # 根据文件类型的不同，处理方法也不同
                if ($fileType == 'img'){
                    # 上传为图片类型
                    $tempUrl = $result['data']['previewUrl'];
                }else{
                    # 上传为附件类型
                    $tempUrl = 'https://sharewh1.xuexi365.com/share/download/'.$result['objectId'];
                }
                $name = $result['data']['name'];
                $error = 0;
            }else{
                $name = '上传错误';
                $error = '上传文件失败';
            }
            // 返回编辑器需要的格式
            $url[$key]['url']   =   $tempUrl ;
            $url[$key]['name']  =   $name;
            $url[$key]['error'] =   $error;
        }
       return json_encode($url);
    }

    // 上传图床到bili 只支持图片
    public function upImgToiceEditorBiliPanTypeBilili($field = 'file')
    {
        // 默认定义返回图片或者附件的空URL ，用于上传错误时候定义样式填充
        $tempUrl = '';
        //获取批量上传的数组键值，也就是说上传的文件数量
        $keys = array_keys($_FILES[$field]['name']);
        foreach ($keys as $key) {
            # 获取上传文件信息
            $file = $_FILES[$field];
            //获取文件的类型
            $fileType = $file['type'][$key];
            $allowType = explode('/',$fileType)[0];
            if ($allowType != 'image'){
                // 只是图床，其他文件不支持
                $name = '上传错误';
                $error = '上传文件类型只能为图片';
            }else{
                //用来处理文件名 ，截图数据的文件名非完整图片名，需要拼接写
                $TempName = $file['name'][$key];
                $pinName = $this->tempGetBoldName($TempName, $fileType);
                # 设置 POST 请求的参数
                $postData = array(
                    "biz" => 'new_dyn',
                    "category" => "daily",
                    "csrf" => '544c24cd8964a19d37a8b541c796f8a3',
                    'file_up' => new \CURLFile($file['tmp_name'][$key], $fileType, $pinName),
                    "cookie" => "buvid3=CA607069-6A1F-EEE3-9D98-933A5784233476413infoc; b_nut=1697695176; i-wanna-go-back=-1; b_ut=7; _uuid=17C1625D-2B79-C1C6-10CFE-FD525B78935D76722infoc; enable_web_push=DISABLE; buvid4=A115BF35-20FD-545A-1F13-38AF530D6E9477286-023101913-xWrW9RW0SscQK7U8oIZPdA%3D%3D; buvid_fp=5209e07efea880b8535fa05292e46ce6; DedeUserID=482265063; DedeUserID__ckMd5=2f98bf65c9a4c58b; CURRENT_FNVAL=4048; rpdid=|(J|)R|YR)kl0J'uYm~YmlkkJ; CURRENT_QUALITY=80; header_theme_version=CLOSE; PVID=1; home_feed_column=5; bp_video_offset_482265063=890853870240006153; b_lsid=4110FF536_18D7F06A46A; browser_resolution=1678-897; SESSDATA=632fc9a3%2C1722785161%2C0e193%2A22CjCSu7RPHhtp7b_X4Z765swJengiYLmeQAFk22qIZTmzbFPmDJ_dMzVlN70mi7E3G38SVmg1U1dLMW02bXlpR00xdmxsN1h5bHYtVzQ0Rm80ODktaXp6MDctVzhFWUFWSnZidDFYcS1zcDJFQ2pWVWM1VkpDT21HaF9scW1xN0M2WFJseTdESFdBIIEC; bili_jct=544c24cd8964a19d37a8b541c796f8a3; LIVE_BUVID=AUTO6317072347726606; bili_ticket=eyJhbGciOiJIUzI1NiIsImtpZCI6InMwMyIsInR5cCI6IkpXVCJ9.eyJleHAiOjE3MDc0OTQxMTMsImlhdCI6MTcwNzIzNDg1MywicGx0IjotMX0.GSsiRTxWMhvWQ-20gz_CmWZWsLKVw7Db-YD7G9gop4Y; bili_ticket_expires=1707494053; sid=ndgrdupk"
                );
                # 创建 cURL 请求
                $response = $this->post_curl("https://api.bilibili.com/x/dynamic/feed/draw/upload_bfs", $postData);
                $result = json_decode($response, true);
                if ($result['code']!=0){
                    $name = '上传错误';
                    $error = '上传文件不支持或者上传失败';
                }else{
                    // 上传成功
                    $tempUrl = $result['data']['image_url'];
                    $name = basename($tempUrl);
                    $error = 0;
                }
            }
            // 返回编辑器需要的格式
            $url[$key]['url']   =   $tempUrl ;
            $url[$key]['name']  =   $name;
            $url[$key]['error'] =   $error;
        }
        return json_encode($url);
    }

    /***
     * 获取截图的文件名称拼接下，如果不是截图的则正常返回对应的文件名
     * @param $tempName
     * @param $fileType
     * @return string|void
     */
    public function tempGetBoldName($tempName,$fileType)
    {
        if($tempName == 'blob'){
            $ext = explode('/',$fileType);
            $pinName =  time().'.'.$ext[1];
        }else{
            $pinName =   $tempName;
        }
        return $pinName;
    }

    /***
     * 上传文件到云盘，有三种类型 图片(img),视频(video)或者文件(其他单词都是文件)
     * @param  $pid 父id
     * @param  $imgType 是否为封面 cover则为封面，默认为null
     * @return string 返回文件直链
     */
    public  function upfiletoyunpan($pid = 0,$imgType='null')
    {
        # 获取上传文件信息
        $file = $_FILES['file'];
        $tempPath = $file['tmp_name'];
        # 判断是否启用压缩图片
        $tempDir = PG_APP_ROOT.'/statics/img/temp/'; // 图片临时上传到哪个目录下
        $compressedPath = $tempDir.'temp'; // 定义一个默认不存在的文件，来效验后期删除使用

        if(c('website','compressImage') == '1' && $imgType == 'cover'){
            // 如果压缩图片，则判断目录是否存在，不存在就创建
            if (!is_dir($tempDir)) {
                mkdir($tempDir, 0777, true);
            }
            $time = time();
            $uploadPath = $tempDir.$time.'.png'; // 上传的图片路径
            $compressedPath = $tempDir.$time.'_comporess.png'; // 压缩后的图片路径 
            move_uploaded_file($tempPath, $uploadPath); 
            $quality = c('website','quality'); // 压缩质量，范围为 0（最差）到 100（最佳）
            compressImage($uploadPath, $compressedPath, $quality);
            // 删除已经上传后的本地文件
            if (file_exists($uploadPath)) { unlink($uploadPath); }   
            $tempPath = $compressedPath;
        } 
        # 设置 POST 请求的参数
        $postData = array(
            "puid"      =>  258413163,
            "_token"    =>  "9910536ff44a3fef3726f34f67c1d0b2",
            "prdid"     =>  440,
            'file'      => new \CURLFile($tempPath, $file['type'], $file['name'])
        );

        # 创建 cURL 请求
        $response = $this->post_curl($this->uploadUrl,$postData);
        // 删除压缩后的图片文件
        if (file_exists($compressedPath)) { unlink($compressedPath); }   

        # 处理网盘上传的响应结果
        $result = json_decode($response, true);

        # 处理数据
        if ($result && $result['result']  ==  1 ) {
            # 获取上传成功后的文件后缀名
            $fileType = $result['data']['suffix'];
            # 根据后缀名统一规划文件类型
            $fileType = $this->getFileType($fileType);
            # 规划默认的视频时长
            $duration = 0;
            # 根据文件类型的不同，处理方法也不同
            if ($fileType == 'img'){
                # 图片类型
                $url = $result['data']['previewUrl'];
                $thumbnail = $url;
            }elseif ($fileType == 'video'){
                # 视频类文件
                $data = $this->FileTypeIsVideoAction($result);
                $url = $data['url'];
                $thumbnail = $data['thumbnail'];
                # 获取视频时长
                $duration =  $this->getVideoCountTime($result['objectId']);
            }else{
                # 其他类文件
                # $url = 'https://sharewh1.xuexi365.com/share/download/'.$result['objectId'];
                $url = '';
                $thumbnail  = $result['data']['thumbnail']  ;
            }
            # 将上传的文件信息格式整理好
           $data = $this->zhengLiData($url,$thumbnail,$fileType,$pid,$result,$duration);
            # 返回上传结果到前台
           return  array('code'=>true,'data'=>$data);
        } else {
            // 上传失败
            return  array('code'=>false,'data'=>"上传失败");
        }
    }

    // 提取小组网盘文件夹下所有的单独文件
    public function tiquGroupAllFile($groupPanUrl,$userid,$pid)
    {
        if(empty($this->set_ChaoXing_Cookie)){return json_encode(array('code'=>'-2','msg'=>'请先在Config.php文件中 设置好超星网盘的Cookie值!'),408);}
        $curl = new curl();
        $curl->set_Cookie = $this->set_ChaoXing_Cookie;
        $content = $curl->get($groupPanUrl);
        //将该接口的请求返回结果值JSON解析，并以数组形式显示
        $contarr =json_decode($content,true) ;
        // 声明一个空数组，用于存放视频信息
        $arr = array();
        if($contarr['result']==1){
            // 提取有结果
            foreach ($contarr['list']  as $key => $v ) {
                $arr[$key]['pan_pid']       = $pid;
                $arr[$key]['pan_name']      = $v['content']['name'];
                $arr[$key]['pan_objectid']  = $v['content']['objectId'];
                $arr[$key]['pan_type']      = $this->getFileType( $v['content']['suffix']);

                # 整理视频 pan_url 和 pan_thumbnail
                switch ($arr[$key]['pan_type']){
                    # 视频类型
                    case "video":
                        $curl->get_Header = true;
                        $v_html = $curl->get($v['content']['thumbnail']);
                        $v_pos1 = strpos($v_html, 'HTTP/1.1') + strlen('HTTP/1.1');
                        $v_pos2 = strpos($v_html, "\r", $v_pos1);
                        $v_httpCode= trimAll(substr($v_html, $v_pos1, $v_pos2 - $v_pos1));
                        if($v_httpCode == "302"){
                            //已经解析过了
                            preg_match('/ananas\.chaoxing\.com\/(.+?)\/snapshot\.jpg/', $v_html, $v_matches);
                            $v_pos = strpos($v_matches[1], 'video/') + strlen('video/');
                            $url = 'https://s138.ananas.chaoxing.com/video/'.substr($v_matches[1], $v_pos).'/sd.mp4';
                        }else{
                            //未解析
                            $url = "null";
                        }
                        $arr[$key]['pan_url']  = $url;
                        $arr[$key]['pan_thumbnail'] = "https://p2.ananas.chaoxing.com/". $v_matches[1]."/snapshot.jpg";
                        break;
                    case "img":
                        # 图片类型
                        $arr[$key]['pan_url']  = $v['content']['previewUrl'];
                        $arr[$key]['pan_thumbnail'] =  $v['content']['previewUrl'];
                        break;
                    default:
                        # 其他类型
                        $arr[$key]['pan_url']  = '';
                        $arr[$key]['pan_thumbnail'] = '';
                        break;
                }
                $arr[$key]['pan_filesize'] = $v['content']['size'];
                $arr[$key]['pan_date'] = time();
                $arr[$key]['user_id'] = $userid;
                #  获取视频时长
                $arr[$key]['pan_duration'] =  $this->getVideoCountTime($v['content']['objectId']);
            }
        }
        return $arr;
    }

    /*********************************************  下面是私有方法，注意私有方法，类外面无法调用  ****************************************************************/

    /***
     * 整理数据
     * @param $url 文件直链
     * @param $thumbnail 文件缩略图
     * @param $type 文件类型
     * @param $result curl请求返回的结果集
     * @param $modelName 数据库模型名称，如果不填写则本函数不生效，填写模型名，本函数会执行保存到数据库操作
     * @return void 无返回值
     */
    private function zhengLiData($url,$thumbnail,$type,$pid,$result,$duration ){
        # 组合数据
        $pan_data= array(
            'pan_name'          =>  $result['data']['name'],    # 上传的文件名
            'pan_pid'           =>  $pid,                       # 父id
            'pan_type'          =>  $type,                      # 上传类型
            'pan_objectid'      =>  $result['objectId'],        # 上传的objectId
            'pan_url'           =>  $url,                       # 存储云盘的链接
            'pan_thumbnail'     =>  $thumbnail,                 # 预览地址
            'pan_filesize'      =>  $result['data']['size'],    # 文件大小
            'pan_date'          =>  time(),                     # 上传的日期 $result['data']['uploadDateFormat']
            'pan_duration'      =>  $duration                   # 获取视频时长 单位为秒
        );
        return $pan_data;
    }

    /**
     * 上传的文件类型是视频的时候，进行二次解析，解析成功返回直链，解析失败(转码中)返回 转码中
     * @param $result
     * @return array
     */
    private function FileTypeIsVideoAction($result){
        $curl = new curl();
        $curl->get_Header = true;
        // 获取跳转页面后的头文件
        $html = $curl->get($result['data']['thumbnail']);

        $pos1 = strpos($html, 'HTTP/1.1') + strlen('HTTP/1.1');
        $pos2 = strpos($html, "\r", $pos1);
        $httpCode= trimAll(substr($html, $pos1, $pos2 - $pos1));
        if($httpCode == "302"){
            //已经解析过了
            preg_match('/ananas\.chaoxing\.com\/(.+?)\/snapshot\.jpg/', $html, $matches);
            $pos = strpos($matches[1], 'video/') + strlen('video/');
            $url = 'https://s138.ananas.chaoxing.com/video/'.substr($matches[1], $pos).'/sd.mp4';

        }else{
            //未解析
            $url = "视频转码中...";
        }
        $thumbnail  = $result['data']['thumbnail'];

        # 返回数据
        return array(
            'url'       =>  $url,     // 直链
            'thumbnail' =>  $thumbnail// 缩略图
        );
    }

    /**
     * curl 上传文件
     * @param $uploadUrl 上传接口
     * @param $postData 上传的参数数组
     * @return array
     */
    private function post_curl($uploadUrl,$postData=null){
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $uploadUrl);
        curl_setopt($curl, CURLOPT_POST, 1);
        if($postData!=null){
            curl_setopt($curl, CURLOPT_POSTFIELDS, $postData);
        }
        if (isset($postData['cookie'])){
            curl_setopt($curl, CURLOPT_COOKIE, $postData['cookie']);
        }


        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($curl);
        curl_close($curl);
        return $response;
    }

    /***
     * 解析视频，通过 缩略图的地址 来解析到真实的视频预览地址
     * 如果视频还没转码完毕，则返回 暂未解析的字样
     * @param $thumbnail 缩略图链接
     * @return string 返回真实视频地址或者解析失败提示
     */
    public function videoGetTrueUrlByThumbnail($thumbnail)
    {
        $curl = new curl();
        $curl->get_Header = true;
        // 获取跳转页面后的头文件
        $html = $curl->get($thumbnail);
        $pos1 = strpos($html, 'HTTP/1.1') + strlen('HTTP/1.1');
        $pos2 = strpos($html, "\r", $pos1);
        $httpCode= trimAll(substr($html, $pos1, $pos2 - $pos1));
        if($httpCode == "302"){
            //已经解析过了
            preg_match('/ananas\.chaoxing\.com\/(.+?)\/snapshot\.jpg/', $html, $matches);
            $pos = strpos($matches[1], 'video/') + strlen('video/');
            $url = 'https://s138.ananas.chaoxing.com/video/'.substr($matches[1], $pos).'/sd.mp4';

        }else{
            //未解析
            $url = "暂未解析";
        }
        return $url;
    }

    /***
     * 获取视频时长，单位秒
     * @param $objectid
     * @return int|mixed
     */
    private function getVideoCountTime($objectid)
    {
        $videoCountTimeSecond = 0;
        $api = "http://note.yd.chaoxing.com/screen/note_note/files/status/".$objectid."?isMedia=true";
        $c = new curl();
        $res  = $c->get($api);
        $res =  json_decode($res, true);
        # 如果是视频类型文件，会有这个值，其他类型文件无此字段
        if(isset($res['duration'] )){
            $videoCountTimeSecond = $res['duration'];
        }
        return $videoCountTimeSecond;
    }

    /***
     * 通过文件的后缀名来判断文件类型
     * @param $suffix 后缀名字符串
     * @return string 返回文件类型
     */
    private function getFileType($suffix){
        #定义文件类型
        $ImgTypeArray   = ['bmp','jpg','jpeg','png','gif','tiff','psd','heic'];
        $VideoTypeArray = ['avi','rmvb','rm','asf','divx','mpg','mpeg','mpe','wmv','mp4','mkv','vob','mov','m4v','flv','3gp','f4v'];
        $AudioTypeArray = ['wma','cd','asf','rm','wav','mp3pro','ape','real','midi','module','aac','vqf','aiff','amr','m4a','midm','ogg','ra','mp3','rma','mod','flac'];
        $PdfTypeArray   = ["pdf"];
        $exeTypeArray   = ["exe"];
        $PPTTypeArray   = ['ppt','pptx'];
        $WordTypeArray  = ['doc','docx'];
        $ExcelTypeArray = ['xls','xlsx','xlt','xlsm','xltm','xlsb'];
        $RarTypeArray   = ['lzh','rar','arj','ace','tar','7-zip','gzip','bz2','iso','xz','zip','jar','uue','cab','7z'];

        $type = null;
        switch ($suffix){
            case in_array($suffix,$ImgTypeArray) :
                $type = "img";
                break;
            case in_array($suffix,$VideoTypeArray) :
                $type =  "video";
                break;
            case in_array($suffix,$AudioTypeArray) :
                $type =  "audio";
                break;
            case in_array($suffix,$exeTypeArray) :
                $type =  "exe";
                break;
            case in_array($suffix,$ExcelTypeArray) :
                $type =  "excel";
                break;
            case in_array($suffix,$WordTypeArray) :
                $type =  "word";
                break;
            case in_array($suffix,$PPTTypeArray) :
                $type =  "ppt";
                break;
            case in_array($suffix,$PdfTypeArray) :
                $type =  "pdf";
                break;
            case in_array($suffix,$RarTypeArray) :
                $type =  "zip";
                break;
            default:
                $type =  'file';
                break;
        }
        return $type ;
    }
}