<?php
/**
 * 文件功能名称 : 图床集合
 * Author     : Kou ( 1002488466@qq.com )
 * CreateTime : 2021/6/14 16:27
 * Description: 图床上传，需要在展示页面添加 代码  <meta name="referrer" content="never">  不然图片会加载不出来 防盗链
 * Version    : 1.1.0
 */
namespace phpGrace\tools;
//  禁用错误报告
error_reporting(0);
//允许所有来源访问  ( 允许跨域 )
header('Access-Control-Allow-Origin:*');

/***
 * Class tuchuang
 * @package phpGrace\tools
 * 调用方式
 * 实例化    $tuchuang = new phpGrace\tools\tuchuang("file");
 * 调用方法： $tuchuang->qq();  $tuchuang->sougou();
 */
class tuchuang
{
    //文件域名称( 也叫做 上传控件名称 )
    public $fileName;

    //目标文件夹( 本地上传 可以用到 ，图床用不到 )
    public $targetDir;

    //上传文件存储大小的限制-默认30M
    public $maxSize = 30 * 102400;

    //子文件夹创建规则  no - 不自动创建  |  y - 年 | m - 月 | d - 日
    public $dirCreateRule = 'no';
    //文件重命名规则  1: 不重命名 | 2: 随机重命名 | 3: _1 后缀形式重命名
    public $renameRule    = 2;
    //上传文件名称自定义(设置后自动重命名将失效)
    public $uploadedFileUseName;
    //错误信息- 本地上传使用
    public $error;
    //支持上传的文件格式
    public $type = ['jpg','jpeg','png','gif','bmp','exe','flv','swf','mkv','avi','rm','rmvb','mpeg','mpg','ogg','ogv','mov','wmv','mp4','webm','mp3','wav','mid','rar','zip','tar','gz','7z','bz2','cab','iso','chm','doc','docx','xls','xlsx','ppt','pptx','pdf','txt','md','xml','torrent'];

    //构造函数,调用函数默认传参
    public function __construct($fileName,$targetDir = "upload")
    {
        $this->fileName = $fileName;
        $this->targetDir = $targetDir; //图片保存目录
    }

    /***
     * 判断文件类型是否允许上传
     * @param $checkName 需要检查的文件名 字符串类型 通过$_FILES['file']['name'] 这样获取
     * @param $key 索引项 类型：数组下标的数字类型
     * @return int 0为允许 1为不允许
     */
    public function checkIsUploadType($checkName,$key){
        $fileExt = strtolower(substr(strrchr($checkName, '.'), 1));
        if(!in_array($fileExt,$this->type)){
            //不允许上传 ，返回详细说明: 该文件类型禁止上传
            $error = 1;
        }else{
            //允许上传，返回0
            $error = 0;
        }
        return $error;
    }

    //搜狗图床  -- 图片有效时间太短了
    public function sougou()
    {
        /* 接口地址 */
        $InterfaceUrl = "http://pic.sogou.com/pic/upload_pic.jsp";
        $keys = array_keys($_FILES[$this->fileName]['name']);
        //通过遍历来处理上传的文件
        foreach ($keys as $key){
            $checkName = $_FILES[$this->fileName]['name'][$key];
            //判断文件类型是否允许上传
            $checkResult = $this->checkIsUploadType($checkName,$key);
            if($checkResult){
                $url[$key]['error'] = "目前使用的是搜狗图床，该文件类型禁止上传。只能上传图片！！！";
                return json_encode($url);exit();
            }
            //开始上传图片
            $fp = fopen($_FILES[$this->fileName]["tmp_name"][$key], "r");
            $img = base64_encode(fread($fp, $_FILES[$this->fileName]["size"][$key]));
            $img = base64_decode($img);
            $data = base64_decode("LS0tLS0tV2ViS2l0Rm9ybUJvdW5kYXJ5R0xmR0IwSGdVTnRwVFQxaw0KQ29udGVudC1EaXNwb3NpdGlvbjogZm9ybS1kYXRhOyBuYW1lPSJwaWNfcGF0aCI7IGZpbGVuYW1lPSIxMS5wbmciDQpDb250ZW50LVR5cGU6IGltYWdlL3BuZw0KDQo=") . $img . base64_decode("DQotLS0tLS1XZWJLaXRGb3JtQm91bmRhcnlHTGZHQjBIZ1VOdHBUVDFrLS0NCg==");
            $ch = curl_init();
            $headers = array(
                "Content-Type: multipart/form-data; boundary=----WebKitFormBoundaryGLfGB0HgUNtpTT1k",
                "Content-Length: " . strlen($data)
            );
            curl_setopt($ch, CURLOPT_URL, $InterfaceUrl);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);
            curl_close($ch);
            /* 匹配图片网址 */
            $url[$key]['url'] = $result;
            /* 匹配错误信息 */
            $url[$key]['error'] = 0;
            /* 匹配图片名称 */
            //匹配文件名
            $url[$key]['name'] ='搜狗_'.substr(strrchr($result, '/'), 1).".png";
        }
        return json_encode($url);
    }


    //QQ图床  - 图片存活时间相对长一些
    public function qq()
    {
        /* 接口地址 */
        $InterfaceUrl = 'https://om.qq.com/image/orginalupload';
        if(!isset($_FILES[$this->fileName])){
            // 如果不是在正常的上传页面post上传的，会提示这个禁止错误
            // ( 测试时没有$this->fileName这个参数会报这个错误 ,比如：直接get方式访问报错)
            $url[0]['name']    =   "Warning: Operation is abnormal. Upload is suspended !";
            $url[0]['error']   =   "Prohibit: upload files on abnormal upload page !";
            $url[0]['url']     =   "404 error, no picture URL !";
            return json_encode($url);exit();
        }
        $keys = array_keys($_FILES[$this->fileName]['name']);
        //通过遍历来处理上传的文件
        foreach ($keys as $key){
            $file = $_FILES[$this->fileName]["tmp_name"][$key];

            $checkName = $_FILES[$this->fileName]['name'][$key];
            //判断文件类型是否允许上传
            $checkResult = $this->checkIsUploadType($checkName,$key);
            if($checkResult){
                $url[$key]['error'] = "目前使用的是腾讯图床，该文件类型禁止上传。只能上传图片！！！";
                return json_encode($url);exit();
            }
            //开始上传照片
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_HEADER, 0);
            curl_setopt($ch, CURLOPT_URL, $InterfaceUrl);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, [
                'Filedata' => new \CURLFile(realpath($file)),
                'subModule' => 'userAuth_individual_head',
                'id' => 'WU_FILE_0',
                'name' => '1574998277549.jpg',
                'type' => 'image/jpeg',
                'lastModifiedDate' => 'Sat Dec 28 2019 22:31:17 GMT 0800 (中国标准时间)',
                'appkey' => '1',
                'isRetImgAttr' => '1',
                'from' => 'user'
            ]);
            if (curl_exec($ch) === false) {
                echo 'Curl error: ' . curl_error($ch);
            }
            $result = curl_exec($ch);
            curl_close($ch);
            //照片上传结束
            $arr = json_decode($result, true);
            /* 匹配图片网址 */
            $url[$key]['url'] =$arr['data']['url']['url'] . ".png";
            /* 匹配错误信息  */
            if($arr['response']['msg'] == "success!"){
                //上传成功
                $url[$key]['error'] = 0;
            }else{
                //上传失败，提示错误信息
                $url[$key]['error'] = $arr['response']['msg'];
            }
            //匹配文件名
            $rule = "/0\/(.*)\/0/i";
            preg_match($rule, $url[$key]['url'] , $imgName);
            $url[$key]['name'] = "腾讯_".$imgName[1].'.png';
        }
        return json_encode($url);
    }

    //本地服务器上传
    public function local(){
        //自动创建子文件夹
        switch ($this->dirCreateRule){
            case 'y':
                $this->targetDir = $this->targetDir.'/'.date('Y');
                break;
            case 'm':
                $this->targetDir = $this->targetDir.'/'.date('Ym');
                break;
            case 'd':
                $this->targetDir = $this->targetDir.'/'.date('Ymd');
                break;
        }
        //检查存放图片的文件夹 是否存在，不存在则创建
        if(!is_dir($this->targetDir)){mkdir($this->targetDir, 0777, true);}

        $keys = array_keys($_FILES[$this->fileName]['name']);
        $setDir = $this->targetDir;
        //通过遍历来处理上传的文件
        foreach ($keys as $key){
            $checkName = $_FILES[$this->fileName]['name'][$key];
            $pathinfo  = pathinfo($checkName);
            //获取文件的后缀名称
            $exeName =  $pathinfo['extension'];
            //获取文件的名称
            $UpfileName = $pathinfo['basename'];

            //判断文件类型是否允许上传
            $checkResult = $this->checkIsUploadType($checkName,$key);
            if($checkResult){ $this->error = " 该文件类型禁止上传。只能上传图片！！！";   }

            //判断文件大小是否超出
            if ($_FILES[$this->fileName]["size"][$key] > $this->maxSize){ $this->error = '该文件太大禁止上传';   }

            //文件重命名
            if(is_null($this->uploadedFileUseName)) {
                //根据重命名规则组合路径信息
                switch ($this->renameRule){
                    case 1:
                        $this->targetDir .=  '/'.$_FILES[$this->fileName]['name'][$key];
                        break;
                    case 2:
                        $this->targetDir .= '/'.uniqid().'.'.$exeName;
                        break;
                    case 3:
                        $frontName = substr($_FILES[$this->fileName]['name'][$key],0,-(strlen($exeName)+1));
                        while(is_file($this->targetDir.'/'.$frontName.'.'.$exeName))
                        {
                            $frontName .= '_1';
                        }
                        $this->targetDir .= '/'.$frontName.'.'.$exeName;

                        break;
                    default:
                        $this->targetDir .= '/'.$_FILES[$this->fileName]['name'][$key];
                }
            }else{
                $this->targetDir .= '/'.$this->uploadedFileUseName;
            }
            //上传
            if(!$this->error){
                //将上传的文件移动到指定目录
                if(move_uploaded_file($_FILES[$this->fileName]['tmp_name'][$key], $this->targetDir)){
                    $url[$key]['url'] =  PG_SROOT.$this->targetDir;
                    $url[$key]['error'] = 0;
                    $url[$key]['name'] = substr(strrchr($this->targetDir, '/'), 1);
                }
            }else{
                $url[$key]['error'] =  $this->error;
            }
            //恢复为原先设定的目录，不然的话文件网址会一直叠加
            $this->targetDir = $setDir;
        }
        return json_encode($url);
    }
}