<?php
// 视频解析类
namespace phpGrace\tools;

class videoPre{
    public $set_B_Cookie ='';          #设置B站Cookie  在config文件中配置
    public $set_ChaoXing_Cookie='';    #设置超星盘的Cookie  在config文件中配置


    /**
     * 统一调配解析视频，不需要去记住多个函数名
     * @param $videoType
     * @param $videoUrlString
     * @return array|jsonarray|string|void
     */
    public function jiexi($videoType,$videoUrlString)
    {
        switch ($videoType){
            case 'b' : # b站单视频
                return $this->getB_one($videoUrlString);
                break;
            case 'b_all': # 通过B站视频总链接，批量提取所有视频集合
                return $this->getB_all($videoUrlString);
                break;
            case 'dy': #抖音视频提取
                return $this->douyin($videoUrlString);
                break;
            case 'xg': #西瓜视频提取
                return $this->xigua($videoUrlString);
                break;
            #通过超星网盘中的视频图片链接提取对应视频短连接
            case 'cxPan_GetVideoSortLink_ByVideoImgLink':
                return $this->cxPan_GetVideoSortLink_ByVideoImgLink($videoUrlString); #此处参数为视频的图片链接
                break;
            # 通过超星小组网盘的目录，批量提取该目录下的所有视频短链接
            case 'cxGroup_GetVideoList_ByListLink':
                return $this->cxGroup_GetVideoList_ByListLink($videoUrlString); #此处参数为目录的链接
                break;
            # 解析 超星网盘里面的视频 不论网盘还是小组网盘，还是已经删除的视频，都可以
            case "cx":
                return $this->chaoxing($videoUrlString);
                break;
            case "st":
                return $this->streamja($videoUrlString);
                break;
            default: return json_encode(array('code'=>'-2','msg'=>'请手动分配解析过滤器类型！'),480);
        }
    }

    /**
     * 解析超星云盘视频
     * @param $url
     * @return void
     */
    private function chaoxing($url)
    {
        $videourl='http://s138.ananas.chaoxing.com/video/'.$url.'/sd.mp4';
        $arr = [
            'code'  => 1,
            'msg'   => '解析成功',
            'data'=>array(
                'video_url'=>$videourl
            )
        ];
        return  json_encode($arr,480);
    }

    /**
     * 通过视频的封面图片链接，提取出视频的短连接
     * @param $VideoImgUrl 视频封面图片链接
     * @return string 视频短链接字符串
     */
    private function cxPan_GetVideoSortLink_ByVideoImgLink($VideoImgUrl)
    {
        # 因为是手动复制图片链接，所以此处只是简单的处理字符串即可
        # 输入参数为视频封面图链接如： https://p2.ananas.chaoxing.com/video/61/88/8f/1a41b66546253181a8acb0b3cc41dc21/snapshot.jpg
        # 最终返回得到的视频短链结果为： 61/88/8f/1a41b66546253181a8acb0b3cc41dc21
        $left = strstr($VideoImgUrl,'/snapshot.jpg',1);
        $right = strstr($left,'/video/') ;
        return str_replace('/video/','', $right);
    }

    # 通过超星小组网盘的目录，批量提取该目录下的所有视频短链接
    private function cxGroup_GetVideoList_ByListLink($videoListLink){
        #需要匹配Cookie
        // cookie需要三个参数，格式为：_d=xxxx;UID=xxxxx;vc3=xxxxx;
        // 调用的时候提前设置cookie， $this->set_ChaoXing_Cookie =''  ;

        if(empty($this->set_ChaoXing_Cookie)){return json_encode(array('code'=>'-2','msg'=>'请先在Config.php文件中 设置好超星网盘的Cookie值!'),408);}
        # 视频目录链接比如：http://groupweb.chaoxing.com/pc/resource/getResourceList?bbsid=2420cabd-11c8-4ff8-9a91-808ba442e09d&folderId=97455&recType=2
        $content = $this->GET($videoListLink,$this->set_ChaoXing_Cookie);
        //将该接口的请求返回结果值JSON解析，并以数组形式显示
        $contarr =json_decode($content,true) ;

        // 声明一个空数组，用于存放视频信息
        $arr = array();
        // 遍历出该文件夹下所有视频  原始OK的
        foreach ($contarr['list']  as $key => $v ) {
            // 得到的视频名称，如果名称中有视频的后缀的，自动去掉后缀
            $arr[$key]['name'] = str_replace(array('.flv','.mp4','.mpeg','.mov','.rmvb','.avi'),'', $v['content']['name']) ;
            // 得到的fileid值
           // $fileid = $v['content']['fileId'];
            $fileid = $v['key'];
            // 预览的官方接口
            $videoapi = 'http://note.yd.chaoxing.com/screen/note_note/files/status/'.$fileid.'?isMedia=true';
            // 请求接口
            $content =  $this->GET($videoapi);
            // JSON解析并以数组形式显示
            $mediaArr = json_decode($content,true);
            //第一步：提取完整url,处理结果为：https://s1.ananas.chaoxing.com/xxx/video/xx/xx/xx/xxxxxx/sd.mp4
            $ResultLeft = strstr($mediaArr['url'],'/sd.mp4?at_=',1);
            // 第二步：提取 提取video右侧部分 /video/XXX/XXX/XXX/XXXXXX/sd.mp4中的xxx部分
            $ResultRight = str_replace('/video/','',strstr($ResultLeft,'/video/' )) ;
            // 前台显示的是不完整的，点击前台，后台请求返回 完整可直链播放的视频网址 'http://s138.ananas.chaoxing.com/video/'.$ResultRight.'/sd.mp4'
            $arr[$key]['fileid'] =  $ResultRight;
        }

        return  array_reverse($arr);

    }

    /**
     * 解析streamja视频床
     * 官网：https://streamja.com/
     * 特点：限制50m，免审，不卡，跳转，永久，免登
     * @param $url上传成功后复制链接里面的短网址后缀
     * @return json
     */
    private function streamja($url)
    {
        //拼接网址
        $url = "https://streamja.com/".$url;
        $content  = $this->GET($url) ;
        //正则匹配
        $reg = '/\<source src=\"(.*?)\" type=\"video\/mp4\"\>/';
        if(preg_match( $reg, $content, $matchRes)){
            $arr['code'] = '1';
            $arr['msg'] = '解析成功';
            $arr['data']['video_url'] = $matchRes[1];
        }else{
            $arr['code'] = '0';
            $arr['msg'] = '解析失败';
        }
        return json_encode($arr,480);
    }

    /**
     * 解析抖音视频
     * @param $url
     * @return array|void
     */
    private function douyin($url)
    {
        $loc = get_headers('https://v.douyin.com/'.$url, true) ['Location'][1];
        preg_match('/video\/(.*)\?/', $loc, $id);
        $arr = json_decode($this->curl('https://www.iesdouyin.com/web/api/v2/aweme/iteminfo/?item_ids=' . $id[1]), true);
        preg_match('/href="(.*?)">Found/', $this->curl(str_replace('playwm', 'play', $arr['item_list'][0]["video"]["play_addr"]["url_list"][0])), $matches);
        $video_url = str_replace('&', '&', $matches[1]);
        if ($video_url) {
            $arr = [
                'code' => 200,
                'msg' => '解析成功',
                'data' => [
                    'title' => $arr['item_list'][0]['share_info']['share_title'],
                    'imgurl' => $arr['item_list'][0]['video']['origin_cover']['url_list'][0],
                    'video_url' => $video_url
                ]
            ];
            return json_encode($arr,408);
        }
    }

    /**
     * 解析西瓜视频，只能是用户上传的视频
     * https://www.ixigua.com/7134062013998694950
     * @param $url 7134062013998694950
     * @return array|void
     */
    private function xigua($url) {
        $url = 'https://www.ixigua.com/' . $url;
        $headers = ["User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/79.0.3945.88 Safari/537.36 ", "cookie:MONITOR_WEB_ID=7892c49b-296e-4499-8704-e47c1b150c18; ixigua-a-s=1; ttcid=af99669b6304453480454f150701d5c226; BD_REF=1; __ac_nonce=060d88ff000a75e8d17eb; __ac_signature=_02B4Z6wo00f01kX9ZpgAAIDAKIBBQUIPYT5F2WIAAPG2ad; ttwid=1%7CcIsVF_3vqSIk4XErhPB0H2VaTxT0tdsTMRbMjrJOPN8%7C1624806049%7C08ce7dd6f7d20506a41ba0a331ef96a6505d96731e6ad9f6c8c709f53f227ab1"];
        $text = $this->curl($url, $headers);
        preg_match('/<script id=\"SSR_HYDRATED_DATA\">window._SSR_HYDRATED_DATA=(.*?)<\/script>/', $text, $jsondata);
        $data = json_decode(str_replace('undefined', 'null', $jsondata[1]), 1);
        $result = $data["anyVideo"]["gidInformation"]["packerData"]["video"];
        #return $result;
        $xiabiao = "video_".count($result["videoResource"]["normal"]["video_list"]);
        $video_url =  base64_decode($result["videoResource"]["normal"]["video_list"][$xiabiao]['main_url']) ;
        $qingXiDu = $result["videoResource"]["normal"]["video_list"][$xiabiao]['definition'];
        $video_cover = $data["anyVideo"]["gidInformation"]["packerData"]["video"]["poster_url"];
        $video_title = $result["title"].'[清晰度'.$qingXiDu.']';
        if ($video_url) {
            $arr = [
                'code' => 200,
                'msg' => '解析成功',
                'data' => [
                    'title'        => $video_title,    #标题
                    'imgurl'       => $video_cover,    #封面
                    'video_url'    => $video_url       #视频直链
                ]
            ];
            return json_encode($arr,480) ;      #JSON加密，文字显示正常
        }
    }

    /**
     * 火山抖音
     * @param $url
     * @return false|string|void
     */
    private function huoshan($url) {
        $loc = get_headers($url, true) ['location'];
        preg_match('/item_id=(.*)&tag/', $loc, $id);
        $arr = json_decode($this->curl('https://share.huoshan.com/api/item/info?item_id=' . $id[1]), true);
        $url = $arr['data']['item_info']['url'];
        preg_match('/video_id=(.*)&line/', $url, $id);
        if ($id) {
            $arr = [
                'code' => 200,
                'msg' => '解析成功',
                'data' => ['cover' => $arr["data"]["item_info"]["cover"],
                    'url' => 'https://api-hl.huoshan.com/hotsoon/item/video/_playback/?video_id=' . $id[1]
                ]
            ];
            return json_encode($arr,408);
        }
    }

    /**
     * 提取B站UP主视频 批量解析
     * @param $url
     * @return void
     */
    private function getB_all($url){
        #先读取Cookie
        $this->set_B_Cookie         =   sc('three_auth_cookie', 'set_B_Cookie');
        if(empty($this->set_B_Cookie)){return json_encode(array('code'=>'-1','msg'=>'请先在Config.php文件中 设置好B站的Cookie值!'),408);}
        $bvid = $url; //视频短链接
        //获取解析需要的cid值和图片以及标题
        $firstUrl = 'https://api.bilibili.com/x/web-interface/view?bvid='.$bvid ;
        $json1 = self::GET($firstUrl,$this->set_B_Cookie);
        $array = json_decode($json1,true);
        // 如果返回代码不等于0 ，则表示网址有错误，解析失败
        if($array['code']!='0'){ return json_encode(['code'=>0, 'msg'=>"解析失败！"],480) ; exit(); }
        # 循环获取
        foreach($array['data']['pages'] as $keys =>$pron){
            //对接上面获取cid值API来取得视频的直链
            $json2 =  self::GET( "https://api.bilibili.com/x/player/playurl?otype=json&fnver=0&fnval=3&player=3&qn=64&bvid=".$bvid."&cid=".$pron['cid']."&platform=html5&high_quality=1");
            $array_2 = json_decode($json2,true);
            $bilijson[] = [
                'title' =>  $pron['part']
                ,'video_url' =>  'https://upos-sz-mirrorhw.bilivideo.com/'.explode('.bilivideo.com/',$array_2['data']['durl'][0]['url'])[1]
            ];
        }
        $JSON = array(
            'code' => 1
        ,'msg' => '解析成功！'
        ,'title' => $array['data']['title']
        ,'imgurl' => $array['data']['pic']
        ,'data' => $bilijson
        );
        return json_encode($JSON ,408);
    }

    /**
     * 解析单个视频
     * @param $url
     * @return jsonarray
     */
    private function getB_one($url){
        $arr = explode('-',$url);  // 将视频页和分集分开
        $u  = $arr[0]; // 网址
        $content =  $this->getB_all($u); //解析
        $content =  json_decode( $content  ,true);
        # 如果解析失败 则返回失败信息
        if($content['code']=='0'){return json_encode(['code'=>0, 'msg'=>"解析失败！"],480) ; }
        # 解析成功，拼装需要返回的信息
        $data['code'] = 1;
        $data['msg'] = '解析成功!';
        if(count($arr)==2){
            $p=$arr[1]; // 分集
            $data['data']['title']=  $content['data'][$p-1]['title'] ;
            $data['data']['video_url'] =  $content['data'][$p-1]['video_url'] ;
        }else{
            $data['data']['title']=    $content['data'][0]['title'] ;
            $data['data']['video_url'] =  $content['data'][0]['video_url'] ; // 单个的标题和视频链接
        }
        $data['data']['imgurl'] = $content['imgurl']; // 封面
        return json_encode($data,408);
    }

    /**
     * CURL通讯请求
     * @param $url
     * @param $cookie
     * @return bool|string
     */
    private function GET($url, $cookie='' ) {
        $header = ['Content-type: application/json;charset=UTF-8'];
        $useragent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/94.0.4606.81 Safari/537.36';
        $ch = curl_init() ;
        curl_setopt($ch, CURLOPT_URL, $url );
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true) ;
        curl_setopt($ch, CURLOPT_HTTPHEADER,$header);
        curl_setopt($ch, CURLOPT_USERAGENT,$useragent);
        curl_setopt($ch, CURLOPT_COOKIE, $cookie);
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, true) ;
        $output = curl_exec($ch) ;
        curl_close ($ch);
        return $output;
    }
    private function curl($url, $headers = []) {
        $header = ['User-Agent:Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1'];
        $con = curl_init((string)$url);
        curl_setopt($con, CURLOPT_HEADER, false);
        curl_setopt($con, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($con, CURLOPT_RETURNTRANSFER, true);
        if (!empty($headers)) {
            curl_setopt($con, CURLOPT_HTTPHEADER, $headers);
        } else {
            curl_setopt($con, CURLOPT_HTTPHEADER, $header);
        }
        curl_setopt($con, CURLOPT_TIMEOUT, 5000);
        $result = curl_exec($con);
        return $result;
    }

}